package com.emoon.system.service.impl;

import cn.hutool.core.collection.CollectionUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.emoon.common.core.utils.MapstructUtils;
import com.emoon.common.core.utils.StringUtils;
import com.emoon.common.mybatis.core.page.PageQuery;
import com.emoon.common.mybatis.core.page.TableDataInfo;
import com.emoon.system.domain.SysProjectDo;
import com.emoon.system.domain.bo.SysProjectBo;
import com.emoon.system.domain.vo.SysProjectVo;
import com.emoon.system.mapper.SysProjectMapper;
import com.emoon.system.service.ISysProjectService;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * @author destiny
 * @description:
 * @date 2025/8/24 18:10
 */
@Service
@RequiredArgsConstructor
public class SysProjectServiceImpl extends ServiceImpl<SysProjectMapper, SysProjectDo> implements ISysProjectService {

    private final SysProjectMapper projectMapper;

    /**
     * 查询项目
     *
     * @param id 主键
     * @return 项目
     */
    @Override
    public SysProjectVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询项目列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 项目分页列表
     */
    @Override
    public TableDataInfo<SysProjectVo> queryPageList(SysProjectBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<SysProjectDo> lqw = buildQueryWrapper(bo);
        Page<SysProjectVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的项目列表
     *
     * @param bo 查询条件
     * @return 项目列表
     */
    @Override
    public List<SysProjectVo> queryList(SysProjectBo bo) {
        LambdaQueryWrapper<SysProjectDo> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<SysProjectDo> buildQueryWrapper(SysProjectBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<SysProjectDo> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(SysProjectDo::getId);
        lqw.eq(bo.getDeptId() != null, SysProjectDo::getDeptId, bo.getDeptId());
        lqw.eq(StringUtils.isNotBlank(bo.getOrganization()), SysProjectDo::getOrganization, bo.getOrganization());
        lqw.eq(StringUtils.isNotBlank(bo.getProject()), SysProjectDo::getProject, bo.getProject());
        lqw.eq(StringUtils.isNotBlank(bo.getPrivateKey()), SysProjectDo::getPrivateKey, bo.getPrivateKey());
        lqw.eq(StringUtils.isNotBlank(bo.getPublicKey()), SysProjectDo::getPublicKey, bo.getPublicKey());
        lqw.eq(CollectionUtil.isNotEmpty(bo.getModelIds()), SysProjectDo::getModelIds, bo.getModelIds());
        lqw.eq(CollectionUtil.isNotEmpty(bo.getRagIds()), SysProjectDo::getRagIds, bo.getRagIds());
        lqw.eq(CollectionUtil.isNotEmpty(bo.getAgentIds()), SysProjectDo::getAgentIds, bo.getAgentIds());
        return lqw;
    }

    /**
     * 新增项目
     *
     * @param bo 项目
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(SysProjectBo bo) {
        SysProjectDo add = MapstructUtils.convert(bo, SysProjectDo.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改项目
     *
     * @param bo 项目
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(SysProjectBo bo) {
        SysProjectDo update = MapstructUtils.convert(bo, SysProjectDo.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(SysProjectDo entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除项目信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
